#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <GL/glu.h>
#include "labyrinth.h"
#include "key_handler.h"

extern board bo;
extern state s;

/**
 * Handles keypresses
 */
void keyhandler(unsigned char key, int x, int y)
{
	switch(key){
		case 'q': exit(0); break;
		case 'z': s.zoom_in = 1; break;
		case 'x': s.zoom_out = 1; break;
		case '0': bo.rotZ = bo.rotX = 0; break;
		case 'v': s.verbose = !s.verbose; break;
		case 'w': s.wireframe = !s.wireframe; break;
	}
}

/**
 * Handles keyreleases
 */
void keyuphandler(unsigned char key, int x, int y)
{
	switch(key){
		case 'z': s.zoom_in = 0; break;
		case 'x': s.zoom_out = 0; break;
	}
}

/**
 * Handles special keypresses
 */
void skeyhandler(int key, int x, int y)
{
	switch(key){
		case ARROW_LEFT: s.left_p = 1; break;
		case ARROW_UP: s.up_p = 1; break;
		case ARROW_RIGHT: s.right_p = 1; break;
		case ARROW_DOWN: s.down_p = 1; break;
	}
}

/**
 * Handles special keyreleases
 */
void skeyuphandler(int key, int x, int y)
{
	switch(key){
		case ARROW_LEFT: s.left_p = 0; break;
		case ARROW_UP: s.up_p = 0; break;
		case ARROW_RIGHT: s.right_p = 0; break;
		case ARROW_DOWN: s.down_p = 0; break;
	}
}
